function log(msg) {
    window.jsObject.log(msg);
}

function setState(state) {
    window.jsObject.setState(state);
}

function isVisible(element) {
    try {
        var css = window.getComputedStyle(element);
        if (css && css['display'] == 'none') {
            return false;
        }
    } catch (e) {
    }

    return true;
}

function clickButton(element) {
    try {
        var evt;

        evt = document.createEvent('UIEvent');
        evt.initUIEvent('touchstart', true, true);
        evt.view = window;
        evt.altKey = false;
        evt.ctrlKey = false;
        evt.shiftKey = false;
        evt.metaKey = false;
        element.dispatchEvent(evt);

        evt = document.createEvent('UIEvent');
        evt.initUIEvent('touchend', true, true);
        evt.view = window;
        evt.altKey = false;
        evt.ctrlKey = false;
        evt.shiftKey = false;
        evt.metaKey = false;
        element.dispatchEvent(evt);

        log('dispatchTouchEndEvent');
    } catch (e) {
        log('exception dispatchTouchEndEvent: ' + e);
    }

    if (element.onclick) {
        log('onclick:' + element.onclick);
        element.onclick();
    } else if (element.click) {
        log('click:' + element.click);
        element.click();
    }
}

function getElementsByFilter(filter, element) {
    if (!element) {
        element = document;
    }

    if (!element.childNodes || element.childNodes.length == 0 || !isVisible(element)) {
        return [];
    }

    var results = [];
    var children = element.childNodes;
    for (var i in children) {
        var child = children[i];

        if (filter(child)) {
            results.push(child);
        }

        var childResults = getElementsByFilter(filter, child);
        if (childResults.length > 0) {
            results = results.concat(childResults);
        }
    }

    return results;
}

function getTextFields() {
    return getElementsByFilter(function(element) {
        if (element.tagName == 'INPUT') {
            if (element.type == 'text' || element.type == 'password') {
                return true;
            }
        } else if (element.tagName == 'textarea') {
            return true;
        }

        return false;
    });
}

function getPasswordFields() {
    return getElementsByFilter(function(element) {
        if (element.tagName == 'INPUT') {
            if (element.type == 'password') {
                log('passwordField:' + element.tagName + ',' + element.type);
                return true;
            }
        }

        return false;
    });
}

function getButtons() {
    return getElementsByFilter(function(element) {
        if (element.tagName == 'INPUT') {
            if (element.type == 'button' || element.type == 'submit') {
                return true;
            }
        } else if (element.tagName == 'BUTTON') {
            log('button:' + element.tagName + ',' + element.type + ',' + element.outerHTML);
            return true;
//        } else if (element.tagName == 'A' && element.onclick) {
//            log('button:' + element.tagName + ',' + element.onclick + ',' + element.outerHTML);
//            return true;
        } else if (element.tagName == 'A') {
            // 中国联通-Global Club 2a:a4:3c:ef:c3:24
            if (element.id == 'codeDiv') {
                return true;
            }
        }

        return false;
    });
}

function getCheckBoxes() {
    return getElementsByFilter(function(element) {
        if (element.tagName == 'INPUT') {
            if (element.type == 'checkbox') {
                return true;
            }
        }

        return false;
    });
}

function checkAllBoxes() {
    var checkBoxes = getCheckBoxes();
    for (var i in checkBoxes) {
        var checkBox = checkBoxes[i];
        if (checkBox.checked) {
            continue;
        }

        checkBox.checked = true;
    }
}

function logon(type, value) {
//    log(document.body.innerHTML);
    log('type=' + type + ', value=' + value);
    if (type == 'auto') {
        var textFields = getTextFields();
        log("textFields: " + textFields.length);
        var buttons = getButtons();
        log("buttons: " + buttons.length);
        if (textFields.length >= 2 && buttons.length >= 2) {
            // 可能是输入手机号进行验证的
            setState('MOBILE')
            return;
        }

        var passwordFields = getPasswordFields();
        log("passwordFields: " + passwordFields.length);
        if (passwordFields.length > 0) {
            // 可能是需要输入网页密码
            setState('PASSWORD');
            return;
        }

        if (buttons.length > 0) {
            // 可能只有一个checkbox
            checkAllBoxes();
            clickButton(buttons[0]);

            setState('FINISHED');
            return;
        }

        log('detect failed');
        setState('DETECT_FAILED');
    } else if (type == 'mobile') {
        var textFields = getTextFields();
        log("textFields: " + textFields.length);
        if (textFields.length < 2) {
            return;
        }

        textFields[0].value = value;

        var buttons = getButtons();
        log("buttons: " + buttons.length);
        if (buttons.length == 0) {
            return;
        }

        setTimeout(function() {
            log('click:' + buttons[0].value);
            clickButton(buttons[0]);

            if (textFields[1].value.length > 0) {
                // SB网站自己填了验证码。。。。
                logon('code');
            } else {
                setState('CODE');
            }
        }, 1000);

    } else if (type == 'password') {
        var passwordFields = getPasswordFields();
        log("passwordFields: " + passwordFields.length);
        if (passwordFields.length == 0) {
            return;
        }
        passwordFields[0].value = value;

        var buttons = getButtons();
        log("buttons: " + buttons.length);
        if (buttons.length == 0) {
            return;
        }

        checkAllBoxes();

        setTimeout(function() {
            log('click:' + buttons[0].value);
            clickButton(buttons[0]);

            setState('FINISHED');
        }, 1000);
    } else if (type == 'code') {
        var textFields = getTextFields();
        log("textFields: " + textFields.length);
        if (textFields.length < 2) {
            return;
        }

        if (value) {
            textFields[1].value = value;
        }

        var buttons = getButtons();
        log("buttons: " + buttons.length);
        if (buttons.length < 2) {
            return;
        }

        checkAllBoxes();

        setTimeout(function() {
            log('click:' + buttons[1].value);
            clickButton(buttons[1]);

            setState('FINISHED');
        }, 1000);
    }
}

(function(type, value) {
    if (type == 'html') {
        return window.document.documentElement.outerHTML;
    }

    setTimeout(function() {
        try {
            logon(type, value);
        } catch (e) {
            log('error logon: ' + e);
            setState('FAILED');
        }
    }, 1000);
})('%s', '%s')